/*!
  * Ender: open module JavaScript framework (client-lib)
  * copyright Dustin Diaz & Jacob Thornton 2011 (@ded @fat)
  * http://ender.no.de
  * License MIT
  */
!function(a){function d(a){var c=b[a]||window[a];if(!c)throw new Error("Requested module '"+a+"' has not been defined.");return c}function e(a,c){return b[a]=c}function f(a,b){for(var c in b)c!="noConflict"&&c!="_VERSION"&&(a[c]=b[c]);return a}function g(a,b,c){return typeof a=="string"||a.nodeName||a.length&&"item"in a||a==window?(c=h._select(a,b),c.selector=a):c=isFinite(a.length)?a:[a],f(c,g)}function h(a,b){return g(a,b)}a.global=a;var b={},c=a.$;a.provide=e,a.require=d,f(h,{_VERSION:"0.3.6",fn:g,ender:function(a,b){f(b?g:h,a)},_select:function(a,b){return(b||document).querySelectorAll(a)}}),f(g,{forEach:function(a,b,c){for(c=0,l=this.length;c<l;++c)c in this&&a.call(b||this[c],this[c],c,this);return this},$:h}),h.noConflict=function(){return a.$=c,this},typeof module!="undefined"&&module.exports&&(module.exports=h),a.ender=a.$=a.ender||h}(this),!function(){var a={exports:{}},b=a.exports;
/*!
    * bean.js - copyright Jacob Thornton 2011
    * https://github.com/fat/bean
    * MIT License
    * special thanks to:
    * dean edwards: http://dean.edwards.name/
    * dperini: https://github.com/dperini/nwevents
    * the entire mootools team: github.com/mootools/mootools-core
    */
!function(b,c,d){typeof a!="undefined"?a.exports=d(b,c):typeof define=="function"&&typeof define.amd=="object"?define(d):c[b]=d(b,c)}("bean",this,function(a,b){var c=window,d=b[a],e=/over|out/,f=/[^\.]*(?=\..*)\.|.*/,g=/\..*/,h="addEventListener",i="attachEvent",j="removeEventListener",k="detachEvent",l=document||{},m=l.documentElement||{},n=m[h],o=n?h:i,p=Array.prototype.slice,q=/click|mouse(?!(.*wheel|scroll))|menu|drag|drop/i,r=/mouse.*(wheel|scroll)/i,s=/^text/i,t=/^touch|^gesture/i,u={one:1},v=function(a,b,c){for(c=0;c<b.length;c++)a[b[c]]=1;return a}({},("click dblclick mouseup mousedown contextmenu mousewheel mousemultiwheel DOMMouseScroll mouseover mouseout mousemove selectstart selectend keydown keypress keyup orientationchange focus blur change reset select submit load unload beforeunload resize move DOMContentLoaded readystatechange error abort scroll "+(n?"show input invalid touchstart touchmove touchend touchcancel gesturestart gesturechange gestureend message readystatechange pageshow pagehide popstate hashchange offline online afterprint beforeprint dragstart dragenter dragover dragleave drag drop dragend loadstart progress suspend emptied stalled loadmetadata loadeddata canplay canplaythrough playing waiting seeking seeked ended durationchange timeupdate play pause ratechange volumechange cuechange checking noupdate downloading cached updateready obsolete ":"")).split(" ")),w=function(){function c(a){var c=a.relatedTarget;return c?c!==this&&c.prefix!=="xul"&&!/document/.test(this.toString())&&!b(c,this):c===null}var a="compareDocumentPosition",b=a in m?function(b,c){return c[a]&&(c[a](b)&16)===16}:"contains"in m?function(a,b){return b=b.nodeType===9||b===window?m:b,b!==a&&b.contains(a)}:function(a,b){while(a=a.parentNode)if(a===b)return 1;return 0};return{mouseenter:{base:"mouseover",condition:c},mouseleave:{base:"mouseout",condition:c},mousewheel:{base:/Firefox/.test(navigator.userAgent)?"DOMMouseScroll":"mousewheel"}}}(),x=function(){var a="altKey attrChange attrName bubbles cancelable ctrlKey currentTarget detail eventPhase getModifierState isTrusted metaKey relatedNode relatedTarget shiftKey srcElement target timeStamp type view which".split(" "),b=a.concat("button buttons clientX clientY dataTransfer fromElement offsetX offsetY pageX pageY screenX screenY toElement".split(" ")),c=b.concat("wheelDelta wheelDeltaX wheelDeltaY wheelDeltaZ axis".split(" ")),d=a.concat("char charCode key keyCode keyIdentifier keyLocation".split(" ")),f=a.concat(["data"]),g=a.concat("touches targetTouches changedTouches scale rotation".split(" ")),h="preventDefault",i=function(a){return function(){a[h]?a[h]():a.returnValue=!1}},j="stopPropagation",k=function(a){return function(){a[j]?a[j]():a.cancelBubble=!0}},n=function(a){return function(){a[h](),a[j](),a.stopped=!0}},o=function(a,b,c){var d,e;for(d=c.length;d--;)e=c[d],!(e in b)&&e in a&&(b[e]=a[e])};return function(p,u){var v={originalEvent:p,isNative:u};if(!p)return v;var w,x=p.type,y=p.target||p.srcElement;v[h]=i(p),v[j]=k(p),v.stop=n(v),v.target=y&&y.nodeType===3?y.parentNode:y;if(u){if(x.indexOf("key")!==-1)w=d,v.keyCode=p.which||p.keyCode;else if(q.test(x)){w=b,v.rightClick=p.which===3||p.button===2,v.pos={x:0,y:0};if(p.pageX||p.pageY)v.clientX=p.pageX,v.clientY=p.pageY;else if(p.clientX||p.clientY)v.clientX=p.clientX+l.body.scrollLeft+m.scrollLeft,v.clientY=p.clientY+l.body.scrollTop+m.scrollTop;e.test(x)&&(v.relatedTarget=p.relatedTarget||p[(x==="mouseover"?"from":"to")+"Element"])}else t.test(x)?w=g:r.test(x)?w=c:s.test(x)&&(w=f);o(p,v,w||a)}return v}}(),y=function(a,b){return!n&&!b&&(a===l||a===c)?m:a},z=function(){function a(a,b,c,d,e){this.element=a,this.type=b,this.handler=c,this.original=d,this.namespaces=e,this.custom=w[b],this.isNative=v[b]&&a[o],this.eventType=n||this.isNative?b:"propertychange",this.customType=!n&&!this.isNative&&b,this.target=y(a,this.isNative),this.eventSupport=this.target[o]}return a.prototype={inNamespaces:function(a){var b,c;if(!a)return!0;if(!this.namespaces)return!1;for(b=a.length;b--;)for(c=this.namespaces.length;c--;)if(a[b]===this.namespaces[c])return!0;return!1},matches:function(a,b,c){return this.element===a&&(!b||this.original===b)&&(!c||this.handler===c)}},a}(),A=function(){var a={},b=function(c,d,e,f,g){if(!d||d==="*")for(var h in a)h.charAt(0)==="$"&&b(c,h.substr(1),e,f,g);else{var i=0,j,k=a["$"+d],l=c==="*";if(!k)return;for(j=k.length;i<j;i++)if(l||k[i].matches(c,e,f))if(!g(k[i],k,i,d))return}},c=function(b,c,d){var e,f=a["$"+c];if(f)for(e=f.length;e--;)if(f[e].matches(b,d,null))return!0;return!1},d=function(a,c,d){var e=[];return b(a,c,d,null,function(a){return e.push(a)}),e},e=function(b){return(a["$"+b.type]||(a["$"+b.type]=[])).push(b),b},f=function(c){b(c.element,c.type,null,c.handler,function(b,c,d){return c.splice(d,1),c.length===0&&delete a["$"+b.type],!1})},g=function(){var b,c=[];for(b in a)b.charAt(0)==="$"&&(c=c.concat(a[b]));return c};return{has:c,get:d,put:e,del:f,entries:g}}(),B=n?function(a,b,c,d){a[d?h:j](b,c,!1)}:function(a,b,c,d,e){e&&d&&a["_on"+e]===null&&(a["_on"+e]=0),a[d?i:k]("on"+b,c)},C=function(a,b,d){var e=b.__beanDel,f=function(f){return f=x(f||((this.ownerDocument||this.document||this).parentWindow||c).event,!0),e&&(f.currentTarget=e.ft(f.target,a)),b.apply(a,[f].concat(d))};return f.__beanDel=e,f},D=function(a,b,d,e,f,g){var h=b.__beanDel,i=function(i){var j=h?h.ft(i.target,a):this;if(e?e.apply(j,arguments):n?!0:i&&i.propertyName==="_on"+d||!i)i&&(i=x(i||((this.ownerDocument||this.document||this).parentWindow||c).event,g),i.currentTarget=j),b.apply(a,i&&(!f||f.length===0)?arguments:p.call(arguments,i?0:1).concat(f))};return i.__beanDel=h,i},E=function(a,b,c,d,e){return function(){a(b,c,e),d.apply(this,arguments)}},F=function(a,b,c,d){var e,f,h,i=b&&b.replace(g,""),j=A.get(a,i,c);for(e=0,f=j.length;e<f;e++)j[e].inNamespaces(d)&&((h=j[e]).eventSupport&&B(h.target,h.eventType,h.handler,!1,h.type),A.del(h))},G=function(a,b,c,d,e){var h,i=b.replace(g,""),j=b.replace(f,"").split(".");if(A.has(a,i,c))return a;i==="unload"&&(c=E(F,a,i,c,d)),w[i]&&(w[i].condition&&(c=D(a,c,i,w[i].condition,e,!0)),i=w[i].base||i),h=A.put(new z(a,i,c,d,j[0]&&j)),h.handler=h.isNative?C(a,h.handler,e):D(a,h.handler,i,!1,e,!1),h.eventSupport&&B(h.target,h.eventType,h.handler,!0,h.customType)},H=function(a,b,c){var d=function(b,d){var e,f=typeof a=="string"?c(a,d):a;for(;b&&b!==d;b=b.parentNode)for(e=f.length;e--;)if(f[e]===b)return b},e=function(a){var c=d(a.target,this);c&&b.apply(c,arguments)};return e.__beanDel={ft:d,selector:a,$:c},e},I=function(a,b,c){var d,e,h,i,j,k=F,l=b&&typeof b=="string";if(l&&b.indexOf(" ")>0){b=b.split(" ");for(j=b.length;j--;)I(a,b[j],c);return a}h=l&&b.replace(g,""),h&&w[h]&&(h=w[h].type);if(!b||l){if(i=l&&b.replace(f,""))i=i.split(".");k(a,h,c,i)}else if(typeof b=="function")k(a,null,b);else for(d in b)b.hasOwnProperty(d)&&I(a,d,b[d]);return a},J=function(a,b,c,d,e){var f,g,h,i,j=c,k=c&&typeof c=="string";if(b&&!c&&typeof b=="object")for(f in b)b.hasOwnProperty(f)&&J.apply(this,[a,f,b[f]]);else{i=arguments.length>3?p.call(arguments,3):[],g=(k?c:b).split(" "),k&&(c=H(b,j=d,e))&&(i=p.call(i,1)),this===u&&(c=E(I,a,b,c,j));for(h=g.length;h--;)G(a,g[h],c,j,i)}return a},K=function(){return J.apply(u,arguments)},L=n?function(a,b,d){var e=l.createEvent(a?"HTMLEvents":"UIEvents");e[a?"initEvent":"initUIEvent"](b,!0,!0,c,1),d.dispatchEvent(e)}:function(a,b,c){c=y(c,a),a?c.fireEvent("on"+b,l.createEventObject()):c["_on"+b]++},M=function(a,b,c){var d,e,h,i,j,k=b.split(" ");for(d=k.length;d--;){b=k[d].replace(g,"");if(i=k[d].replace(f,""))i=i.split(".");if(!i&&!c&&a[o])L(v[b],b,a);else{j=A.get(a,b),c=[!1].concat(c);for(e=0,h=j.length;e<h;e++)j[e].inNamespaces(i)&&j[e].handler.apply(a,c)}}return a},N=function(a,b,c){var d=0,e=A.get(b,c),f=e.length,g,h;for(;d<f;d++)e[d].original&&(h=e[d].handler.__beanDel,h?g=[a,h.selector,e[d].type,e[d].original,h.$]:g=[a,e[d].type,e[d].original],J.apply(null,g));return a},O={add:J,one:K,remove:I,ne:N,fire:M,noConflict:function(){return b[a]=d,this}};if(c[i]){var P=function(){var a,b=A.entries();for(a in b)b[a].type&&b[a].type!=="unload"&&I(b[a].element,b[a].type);c[k]("onunload",P),c.CollectGarbage&&c.CollectGarbage()};c[i]("onunload",P)}return O}),provide("bean",a.exports),!function(a){var b=require("bean"),c=function(c,d,e){var f=d?[d]:[];return function(){for(var e,g=0,h=this.length;g<h;g++)e=[this[g]].concat(f,Array.prototype.slice.call(arguments,0)),e.length==4&&e.push(a),!arguments.length&&c=="add"&&d&&(c="fire"),b[c].apply(this,e);return this}},d=c("add"),e=c("remove"),f=c("fire"),g={on:d,addListener:d,bind:d,listen:d,delegate:d,one:c("one"),off:e,unbind:e,unlisten:e,removeListener:e,undelegate:e,emit:f,trigger:f,cloneEvents:c("clone"),hover:function(a,c,d){for(d=this.length;d--;)b.add.call(this,this[d],"mouseenter",a),b.add.call(this,this[d],"mouseleave",c);return this}},h=["blur","change","click","dblclick","error","focus","focusin","focusout","keydown","keypress","keyup","load","mousedown","mouseenter","mouseleave","mouseout","mouseover","mouseup","mousemove","resize","scroll","select","submit","unload"];for(var i=h.length;i--;)g[h[i]]=c("add",h[i]);a.ender(g,!0)}(ender)}(),!function(){var a={exports:{}},b=a.exports;
/*!
    * Bonzo: DOM Utility (c) Dustin Diaz 2012
    * https://github.com/ded/bonzo
    * License MIT
    */
!function(b,c){typeof a!="undefined"?a.exports=c():typeof define=="function"&&define.amd?define(b,c):this[b]=c()}("bonzo",function(){function G(a){return new RegExp("(^|\\s+)"+a+"(\\s+|$)")}function H(a,b,c){for(var d=0,e=a.length;d<e;d++)b.call(c||a[d],a[d],d,a);return a}function I(a,b,c){for(var d=0,e=a.length;d<e;d++)O(a[d])&&(I(a[d].childNodes,b,c),b.call(c||a[d],a[d],d,a));return a}function J(a){return a.replace(/-(.)/g,function(a,b){return b.toUpperCase()})}function K(a){return a?a.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase():a}function L(a){return a[y]("data-node-uid")||a[x]("data-node-uid",++t),uid=a[y]("data-node-uid"),s[uid]||(s[uid]={})}function M(a){uid=a[y]("data-node-uid"),uid&&delete s[uid]}function N(a,b){try{return a===null||a===undefined?undefined:a==="true"?!0:a==="false"?!1:a==="null"?null:(b=parseFloat(a))==a?b:a}catch(c){}return undefined}function O(a){return a&&a.nodeName&&a.nodeType==1}function P(a,b,c,d,e){for(d=0,e=a.length;d<e;++d)if(b.call(c,a[d],d,a))return!0;return!1}function Q(a){return a=="transform"&&(a=A.transform)||/^transform-?[Oo]rigin$/.test(a)&&(a=A.transform+"Origin")||a=="float"&&(a=A.cssFloat),a?J(a):null}function S(a,b,c){var d=0,g=b||this,h=[],i=f&&typeof a=="string"&&a.charAt(0)!="<"?f(a):a;return H(W(i),function(a){H(g,function(b){var f=!b[e]||b[e]&&!b[e][e]?function(){var a=b.cloneNode(!0);return g.$&&g.cloneEvents&&g.$(a).cloneEvents(b),a}():b;c(a,f),h[d]=f,d++})},this),H(h,function(a,b){g[b]=a}),g.length=d,g}function T(a,b,c){var d=$(a),e=d.css("position"),f=d.offset(),g="relative",h=e==g,i=[parseInt(d.css("left"),10),parseInt(d.css("top"),10)];e=="static"&&(d.css("position",g),e=g),isNaN(i[0])&&(i[0]=h?0:a.offsetLeft),isNaN(i[1])&&(i[1]=h?0:a.offsetTop),b!=null&&(a.style.left=b-f.left+i[0]+w),c!=null&&(a.style.top=c-f.top+i[1]+w)}function U(a,b){return typeof b=="function"?b(a):b}function V(a){this.length=0;if(a){a=typeof a!="string"&&!a.nodeType&&typeof a.length!="undefined"?a:[a],this.length=a.length;for(var b=0;b<a.length;b++)this[b]=a[b]}}function W(a){return typeof a=="string"?$.create(a):O(a)?[a]:a}function X(a,c,d){var e=this[0];return e?a==null&&c==null?(Y(e)?Z():{x:e.scrollLeft,y:e.scrollTop})[d]:(Y(e)?b.scrollTo(a,c):(a!=null&&(e.scrollLeft=a),c!=null&&(e.scrollTop=c)),this):this}function Y(a){return a===b||/^(?:body|html)$/i.test(a.tagName)}function Z(){return{x:b.pageXOffset||d.scrollLeft,y:b.pageYOffset||d.scrollTop}}function $(a,b){return new V(a,b)}var a=this,b=window,c=b.document,d=c.documentElement,e="parentNode",f=null,g=/^(checked|value|selected)$/i,h=/^(select|fieldset|table|tbody|tfoot|td|tr|colgroup)$/i,i=["<table>","</table>",1],j=["<table><tbody><tr>","</tr></tbody></table>",3],k=["<select>","</select>",1],l=["_","",0,1],m={thead:i,tbody:i,tfoot:i,colgroup:i,caption:i,tr:["<table><tbody>","</tbody></table>",2],th:j,td:j,col:["<table><colgroup>","</colgroup></table>",2],fieldset:["<form>","</form>",1],legend:["<form><fieldset>","</fieldset></form>",2],option:k,optgroup:k,script:l,style:l,link:l,param:l,base:l},n=/^(checked|selected)$/,o=/msie/i.test(navigator.userAgent),p,q,r,s={},t=0,u=/^-?[\d\.]+$/,v=/^data-(.+)$/,w="px",x="setAttribute",y="getAttribute",z="getElementsByTagName",A=function(){var a=c.createElement("p");return a.innerHTML='<a href="#x">x</a><table style="float:left;"></table>',{hrefExtended:a[z]("a")[0][y]("href")!="#x",autoTbody:a[z]("tbody").length!==0,computedStyle:c.defaultView&&c.defaultView.getComputedStyle,cssFloat:a[z]("table")[0].style.styleFloat?"styleFloat":"cssFloat",transform:function(){var b=["webkitTransform","MozTransform","OTransform","msTransform","Transform"],c;for(c=0;c<b.length;c++)if(b[c]in a.style)return b[c]}(),classList:"classList"in a}}(),B=/(^\s*|\s*$)/g,C=/\s+/,D=String.prototype.toString,E={lineHeight:1,zoom:1,zIndex:1,opacity:1},F=String.prototype.trim?function(a){return a.trim()}:function(a){return a.replace(B,"")},R=A.computedStyle?function(a,b){var d=null,e=c.defaultView.getComputedStyle(a,"");return e&&(d=e[b]),a.style[b]||d}:o&&d.currentStyle?function(a,b){if(b=="opacity"){var c=100;try{c=a.filters["DXImageTransform.Microsoft.Alpha"].opacity}catch(d){try{c=a.filters("alpha").opacity}catch(e){}}return c/100}var f=a.currentStyle?a.currentStyle[b]:null;return a.style[b]||f}:function(a,b){return a.style[b]};return A.classList?(p=function(a,b){return a.classList.contains(b)},q=function(a,b){a.classList.add(b)},r=function(a,b){a.classList.remove(b)}):(p=function(a,b){return G(b).test(a.className)},q=function(a,b){a.className=F(a.className+" "+b)},r=function(a,b){a.className=F(a.className.replace(G(b)," "))}),V.prototype={get:function(a){return this[a]||null},each:function(a,b){return H(this,a,b)},deepEach:function(a,b){return I(this,a,b)},map:function(a,b){var c=[],d,e;for(e=0;e<this.length;e++)d=a.call(this,this[e],e),b?b(d)&&c.push(d):c.push(d);return c},html:function(a,b){function e(b){H(W(a),function(a){b.appendChild(a)})}var c=b?d.textContent===undefined?"innerText":"textContent":"innerHTML";return typeof a!="undefined"?this.empty().each(function(d){!b&&h.test(d.tagName)?e(d):!function(){try{d[c]=a}catch(b){e(d)}}()}):this[0]?this[0][c]:""},text:function(a){return this.html(a,1)},append:function(a){return this.each(function(b){H(W(a),function(a){b.appendChild(a)})})},prepend:function(a){return this.each(function(b){var c=b.firstChild;H(W(a),function(a){b.insertBefore(a,c)})})},appendTo:function(a,b){return S.call(this,a,b,function(a,b){a.appendChild(b)})},prependTo:function(a,b){return S.call(this,a,b,function(a,b){a.insertBefore(b,a.firstChild)})},before:function(a){return this.each(function(b){H($.create(a),function(a){b[e].insertBefore(a,b)})})},after:function(a){return this.each(function(b){H($.create(a),function(a){b[e].insertBefore(a,b.nextSibling)})})},insertBefore:function(a,b){return S.call(this,a,b,function(a,b){a[e].insertBefore(b,a)})},insertAfter:function(a,b){return S.call(this,a,b,function(a,b){var c=a.nextSibling;c?a[e].insertBefore(b,c):a[e].appendChild(b)})},replaceWith:function(a){return this.deepEach(M),this.each(function(b){b.parentNode.replaceChild($.create(a)[0],b)})},addClass:function(a){return a=D.call(a).split(C),this.each(function(b){H(a,function(a){a&&!p(b,U(b,a))&&q(b,U(b,a))})})},removeClass:function(a){return a=D.call(a).split(C),this.each(function(b){H(a,function(a){a&&p(b,U(b,a))&&r(b,U(b,a))})})},hasClass:function(a){return a=D.call(a).split(C),P(this,function(b){return P(a,function(a){return a&&p(b,a)})})},toggleClass:function(a,b){return a=D.call(a).split(C),this.each(function(c){H(a,function(a){a&&(typeof b!="undefined"?b?q(c,a):r(c,a):p(c,a)?r(c,a):q(c,a))})})},show:function(a){return this.each(function(b){b.style.display=a||""})},hide:function(){return this.each(function(a){a.style.display="none"})},toggle:function(a,b){return this.each(function(a){a.style.display=a.offsetWidth||a.offsetHeight?"none":b||""}),a&&a(),this},first:function(){return $(this.length?this[0]:[])},last:function(){return $(this.length?this[this.length-1]:[])},next:function(){return this.related("nextSibling")},previous:function(){return this.related("previousSibling")},parent:function(){return this.related(e)},related:function(a){return this.map(function(b){b=b[a];while(b&&b.nodeType!==1)b=b[a];return b||0},function(a){return a})},focus:function(){return this.length&&this[0].focus(),this},blur:function(){return this.each(function(a){a.blur()})},css:function(a,d,e){function g(a,b,c){for(var d in f)f.hasOwnProperty(d)&&(c=f[d],(b=Q(d))&&u.test(c)&&!(b in E)&&(c+=w),a.style[b]=U(a,c))}if(d===undefined&&typeof a=="string")return d=this[0],d?d===c||d===b?(e=d===c?$.doc():$.viewport(),a=="width"?e.width:a=="height"?e.height:""):(a=Q(a))?R(d,a):null:null;var f=a;return typeof a=="string"&&(f={},f[a]=d),o&&f.opacity&&(f.filter="alpha(opacity="+f.opacity*100+")",f.zoom=a.zoom||1,delete f.opacity),this.each(g)},offset:function(a,b){if(typeof a=="number"||typeof b=="number")return this.each(function(c){T(c,a,b)});if(!this[0])return{top:0,left:0,height:0,width:0};var c=this[0],d=c.offsetWidth,e=c.offsetHeight,f=c.offsetTop,g=c.offsetLeft;while(c=c.offsetParent)f+=c.offsetTop,g+=c.offsetLeft;return{top:f,left:g,height:e,width:d}},dim:function(){if(!this.length)return{height:0,width:0};var a=this[0],b=!a.offsetWidth&&!a.offsetHeight?function(b,c){return c={position:a.style.position||"",visibility:a.style.visibility||"",display:a.style.display||""},b.first().css({position:"absolute",visibility:"hidden",display:"block"}),c}(this):null,c=a.offsetWidth,d=a.offsetHeight;return b&&this.first().css(b),{height:d,width:c}},attr:function(a,b){var c=this[0];if(typeof a=="string"||a instanceof String)return typeof b=="undefined"?c?g.test(a)?n.test(a)&&typeof c[a]=="string"?!0:c[a]:a!="href"&&a!="src"||!A.hrefExtended?c[y](a):c[y](a,2):null:this.each(function(c){g.test(a)?c[a]=U(c,b):c[x](a,U(c,b))});for(var d in a)a.hasOwnProperty(d)&&this.attr(d,a[d]);return this},removeAttr:function(a){return this.each(function(b){n.test(a)?b[a]=!1:b.removeAttribute(a)})},val:function(a){return typeof a=="string"?this.attr("value",a):this.length?this[0].value:null},data:function(a,b){var c=this[0],d,e,f;return typeof b=="undefined"?c?(e=L(c),typeof a=="undefined"?(H(c.attributes,function(a){(f=(""+a.name).match(v))&&(e[J(f[1])]=N(a.value))}),e):(typeof e[a]=="undefined"&&(e[a]=N(this.attr("data-"+K(a)))),e[a])):null:this.each(function(c){L(c)[a]=b})},remove:function(){return this.deepEach(M),this.each(function(a){a[e]&&a[e].removeChild(a)})},empty:function(){return this.each(function(a){I(a.childNodes,M);while(a.firstChild)a.removeChild(a.firstChild)})},detach:function(){return this.map(function(a){return a[e].removeChild(a)})},scrollTop:function(a){return X.call(this,null,a,"y")},scrollLeft:function(a){return X.call(this,a,null,"x")}},$.setQueryEngine=function(a){f=a,delete $.setQueryEngine},$.aug=function(a,b){for(var c in a)a.hasOwnProperty(c)&&((b||V.prototype)[c]=a[c])},$.create=function(a){return typeof a=="string"&&a!==""?function(){var b=/^\s*<([^\s>]+)/.exec(a),d=c.createElement("div"),f=[],g=b?m[b[1].toLowerCase()]:null,h=g?g[2]+1:1,i=g&&g[3],j=e,k=A.autoTbody&&g&&g[0]=="<table>"&&!/<tbody/i.test(a);d.innerHTML=g?g[0]+a+g[1]:a;while(h--)d=d.firstChild;i&&d&&d.nodeType!==1&&(d=d.nextSibling);do(!b||d.nodeType==1)&&(!k||d.tagName.toLowerCase()!="tbody")&&f.push(d);while(d=d.nextSibling);return H(f,function(a){a[j]&&a[j].removeChild(a)}),f}():O(a)?[a.cloneNode(!0)]:[]},$.doc=function(){var a=$.viewport();return{width:Math.max(c.body.scrollWidth,d.scrollWidth,a.width),height:Math.max(c.body.scrollHeight,d.scrollHeight,a.height)}},$.firstChild=function(a){for(var b=a.childNodes,c=0,d=b&&b.length||0,e;c<d;c++)b[c].nodeType===1&&(e=b[d=c]);return e},$.viewport=function(){return{width:o?d.clientWidth:self.innerWidth,height:o?d.clientHeight:self.innerHeight}},$.isAncestor="compareDocumentPosition"in d?function(a,b){return(a.compareDocumentPosition(b)&16)==16}:"contains"in d?function(a,b){return a!==b&&a.contains(b)}:function(a,b){while(b=b[e])if(b===a)return!0;return!1},$}),provide("bonzo",a.exports),!function(a){function c(a,b){for(var c=0;c<a.length;c++)if(a[c]===b)return c;return-1}function d(a){var b=[],c=0,d=0,e,f,g;for(;f=a[c];++c){g=!1;for(e=0;e<b.length;++e)if(b[e]===f){g=!0;break}g||(b[d++]=f)}return b}function e(a,c){return typeof c=="undefined"?b(this).dim()[a]:this.css(a,c)}var b=require("bonzo");b.setQueryEngine(a),a.ender(b),a.ender(b(),!0),a.ender({create:function(c){return a(b.create(c))}}),a.id=function(b){return a([document.getElementById(b)])},a.ender({parents:function(b,e){if(!this.length)return this;var f=a(b),g,h,i,j=[];for(g=0,h=this.length;g<h;g++){i=this[g];while(i=i.parentNode)if(~c(f,i)){j.push(i);if(e)break}}return a(d(j))},parent:function(){return a(d(b(this).parent()))},closest:function(a){return this.parents(a,!0)},first:function(){return a(this.length?this[0]:this)},last:function(){return a(this.length?this[this.length-1]:[])},next:function(){return a(b(this).next())},previous:function(){return a(b(this).previous())},appendTo:function(a){return b(this.selector).appendTo(a,this)},prependTo:function(a){return b(this.selector).prependTo(a,this)},insertAfter:function(a){return b(this.selector).insertAfter(a,this)},insertBefore:function(a){return b(this.selector).insertBefore(a,this)},siblings:function(){var b,c,d,e=[];for(b=0,c=this.length;b<c;b++){d=this[b];while(d=d.previousSibling)d.nodeType==1&&e.push(d);d=this[b];while(d=d.nextSibling)d.nodeType==1&&e.push(d)}return a(e)},children:function(){var c,e,f=[];for(c=0,l=this.length;c<l;c++){if(!(e=b.firstChild(this[c])))continue;f.push(e);while(e=e.nextSibling)e.nodeType==1&&f.push(e)}return a(d(f))},height:function(a){return e.call(this,"height",a)},width:function(a){return e.call(this,"width",a)}},!0)}(ender)}(),!function(){var a={exports:{}},b=a.exports;
/*!
    * domready (c) Dustin Diaz 2012 - License MIT
    */
!function(b,c){typeof a!="undefined"?a.exports=c():typeof define=="function"&&typeof define.amd=="object"?define(c):this[b]=c()}("domready",function(a){function m(a){l=1;while(a=b.shift())a()}var b=[],c,d=!1,e=document,f=e.documentElement,g=f.doScroll,h="DOMContentLoaded",i="addEventListener",j="onreadystatechange",k="readyState",l=/^loade|c/.test(e[k]);return e[i]&&e[i](h,c=function(){e.removeEventListener(h,c,d),m()},d),g&&e.attachEvent(j,c=function(){/^c/.test(e[k])&&(e.detachEvent(j,c),m())}),a=g?function(c){self!=top?l?c():b.push(c):function(){try{f.doScroll("left")}catch(b){return setTimeout(function(){a(c)},50)}c()}()}:function(a){l?a():b.push(a)}}),provide("domready",a.exports),!function(a){var b=require("domready");a.ender({domReady:b}),a.ender({ready:function(a){return b(a),this}},!0)}(ender)}(),!function(){var a={exports:{}},b=a.exports;
/*!
    * Qwery - A Blazing Fast query selector engine
    * https://github.com/ded/qwery
    * copyright Dustin Diaz & Jacob Thornton 2011
    * MIT License
    */
!function(b,c){typeof a!="undefined"?a.exports=c():typeof define=="function"&&typeof define.amd=="object"?define(c):this[b]=c()}("qwery",function(){function C(){this.c={}}function H(a){return D.g(a)||D.s(a,"(^|\\s+)"+a+"(\\s+|$)",1)}function I(a,b){var c=0,d=a.length;for(;c<d;c++)b(a[c])}function J(a){for(var b=[],c=0,d=a.length;c<d;++c)V(a[c])?b=b.concat(a[c]):b[b.length]=a[c];return b}function K(a){var b=0,c=a.length,d=[];for(;b<c;b++)d[b]=a[b];return d}function L(a){while(a=a.previousSibling)if(a[h]==1)break;return a}function M(a){return a.match(A)}function N(a,b,c,d,e,f,i,l,m,n,o){var p,q,r,s,t;if(this[h]!==1)return!1;if(b&&b!=="*"&&this[g]&&this[g].toLowerCase()!==b)return!1;if(c&&(q=c.match(j))&&q[1]!==this.id)return!1;if(c&&(t=c.match(k)))for(p=t.length;p--;)if(!H(t[p].slice(1)).test(this.className))return!1;if(m&&Y.pseudos[m]&&!Y.pseudos[m](this,o))return!1;if(d&&!i){s=this.attributes;for(r in s)if(Object.prototype.hasOwnProperty.call(s,r)&&(s[r].name||r)==e)return this}return d&&!P(f,_(this,e)||"",i)?!1:this}function O(a){return E.g(a)||E.s(a,a.replace(t,"\\$1"))}function P(a,b,c){switch(a){case"=":return b==c;case"^=":return b.match(F.g("^="+c)||F.s("^="+c,"^"+O(c),1));case"$=":return b.match(F.g("$="+c)||F.s("$="+c,O(c)+"$",1));case"*=":return b.match(F.g(c)||F.s(c,O(c),1));case"~=":return b.match(F.g("~="+c)||F.s("~="+c,"(?:^|\\s+)"+O(c)+"(?:\\s+|$)",1));case"|=":return b.match(F.g("|="+c)||F.s("|="+c,"^"+O(c)+"(-|$)",1))}return 0}function Q(a,b){var c=[],e=[],f,i,j,k,m,n,o,p,q=b,r=G.g(a)||G.s(a,a.split(z)),s=a.match(y);if(!r.length)return c;k=(r=r.slice(0)).pop(),r.length&&(j=r[r.length-1].match(l))&&(q=X(b,j[1]));if(!q)return c;o=M(k),n=q!==b&&q[h]!==9&&s&&/^[+~]$/.test(s[s.length-1])?function(a){while(q=q.nextSibling)q[h]==1&&(o[1]?o[1]==q[g].toLowerCase():1)&&(a[a.length]=q);return a}([]):q[d](o[1]||"*");for(f=0,i=n.length;f<i;f++)if(p=N.apply(n[f],o))c[c.length]=p;return r.length?(I(c,function(a){S(a,r,s)&&(e[e.length]=a)}),e):c}function R(a,b,c){if(T(b))return a==b;if(V(b))return!!~J(b).indexOf(a);var d=b.split(","),e,f;while(b=d.pop()){e=G.g(b)||G.s(b,b.split(z)),f=b.match(y),e=e.slice(0);if(N.apply(a,M(e.pop()))&&(!e.length||S(a,e,f,c)))return!0}return!1}function S(a,b,c,d){function f(a,d,g){while(g=B[c[d]](g,a))if(T(g)&&N.apply(g,M(b[d]))){if(!d)return g;if(e=f(g,d-1,g))return e}}var e;return(e=f(a,b.length-1,a))&&(!d||$(e,d))}function T(a,b){return a&&typeof a=="object"&&(b=a[h])&&(b==1||b==9)}function U(a){var b=[],c,d;a:for(c=0;c<a.length;++c){for(d=0;d<b.length;++d)if(b[d]==a[c])continue a;b[b.length]=a[c]}return b}function V(a){return typeof a=="object"&&isFinite(a.length)}function W(b){return b?typeof b=="string"?Y(b)[0]:!b[h]&&V(b)?b[0]:b:a}function X(a,b,c){return a[h]===9?a.getElementById(b):a.ownerDocument&&((c=a.ownerDocument.getElementById(b))&&$(c,a)&&c||!$(a,a.ownerDocument)&&i('[id="'+b+'"]',a)[0])}function Y(a,b){var e,f,g=W(b);if(!g||!a)return[];if(a===window||T(a))return!b||a!==window&&T(g)&&$(a,g)?[a]:[];if(a&&V(a))return J(a);if(e=a.match(x)){if(e[1])return(f=X(g,e[1]))?[f]:[];if(e[2])return K(g[d](e[2]));if(ba&&e[3])return K(g[c](e[3]))}return i(a,g)}function Z(a,b){return function(c){var d,e;if(p.test(c)){a[h]!==9&&((e=d=a.getAttribute("id"))||a.setAttribute("id",e="__qwerymeupscotty"),c='[id="'+e+'"]'+c,b(a.parentNode||a,c,!0),d||a.removeAttribute("id"));return}c.length&&b(a,c,!1)}}var a=document,b=a.documentElement,c="getElementsByClassName",d="getElementsByTagName",e="querySelectorAll",f="useNativeQSA",g="tagName",h="nodeType",i,j=/#([\w\-]+)/,k=/\.[\w\-]+/g,l=/^#([\w\-]+)$/,m=/^\.([\w\-]+)$/,n=/^([\w\-]+)$/,o=/^([\w]+)?\.([\w\-]+)$/,p=/(^|,)\s*[>~+]/,q=/^\s+|\s*([,\s\+\~>]|$)\s*/g,r=/[\s\>\+\~]/,s=/(?![\s\w\-\/\?\&\=\:\.\(\)\!,@#%<>\{\}\$\*\^'"]*\]|[\s\w\+\-]*\))/,t=/([.*+?\^=!:${}()|\[\]\/\\])/g,u=/^(\*|[a-z0-9]+)?(?:([\.\#]+[\w\-\.#]+)?)/,v=/\[([\w\-]+)(?:([\|\^\$\*\~]?\=)['"]?([ \w\-\/\?\&\=\:\.\(\)\!,@#%<>\{\}\$\*\^]+)["']?)?\]/,w=/:([\w\-]+)(\(['"]?([^()]+)['"]?\))?/,x=new RegExp(l.source+"|"+n.source+"|"+m.source),y=new RegExp("("+r.source+")"+s.source,"g"),z=new RegExp(r.source+s.source),A=new RegExp(u.source+"("+v.source+")?"+"("+w.source+")?"),B={" ":function(a){return a&&a!==b&&a.parentNode},">":function(a,b){return a&&a.parentNode==b.parentNode&&a.parentNode},"~":function(a){return a&&a.previousSibling},"+":function(a,b,c,d){return a?(c=L(a))&&(d=L(b))&&c==d&&c:!1}};C.prototype={g:function(a){return this.c[a]||undefined},s:function(a,b,c){return b=c?new RegExp(b):b,this.c[a]=b}};var D=new C,E=new C,F=new C,G=new C,$="compareDocumentPosition"in b?function(a,b){return(b.compareDocumentPosition(a)&16)==16}:"contains"in b?function(a,c){return c=c[h]===9||c==window?b:c,c!==a&&c.contains(a)}:function(a,b){while(a=a.parentNode)if(a===b)return 1;return 0},_=function(){var b=a.createElement("p");return(b.innerHTML='<a href="#x">x</a>')&&b.firstChild.getAttribute("href")!="#x"?function(a,b){return b==="class"?a.className:b==="href"||b==="src"?a.getAttribute(b,2):a.getAttribute(b)}:function(a,b){return a.getAttribute(b)}}(),ba=!!a[c],bb=a.querySelector&&a[e],bc=function(a,b){var c=[],d,f;try{return b[h]===9||!p.test(a)?K(b[e](a)):(I(d=a.split(","),Z(b,function(a,b){f=a[e](b),f.length==1?c[c.length]=f.item(0):f.length&&(c=c.concat(K(f)))})),d.length>1&&c.length>1?U(c):c)}catch(g){}return bd(a,b)},bd=function(a,b){var c=[],e,f,g,i,j,k;a=a.replace(q,"$1");if(f=a.match(o)){j=H(f[2]),e=b[d](f[1]||"*");for(g=0,i=e.length;g<i;g++)j.test(e[g].className)&&(c[c.length]=e[g]);return c}return I(k=a.split(","),Z(b,function(a,d,e){j=Q(d,a);for(g=0,i=j.length;g<i;g++)if(a[h]===9||e||$(j[g],b))c[c.length]=j[g]})),k.length>1&&c.length>1?U(c):c},be=function(a){typeof a[f]!="undefined"&&(i=a[f]?bb?bc:bd:bd)};return be({useNativeQSA:!0}),Y.configure=be,Y.uniq=U,Y.is=R,Y.pseudos={},Y}),provide("qwery",a.exports),!function(a,b){var c=require("qwery");b.pseudos=c.pseudos,b._select=function(a,d){return(b._select=function(a){try{return a=require("bonzo"),function(b,d){return/^\s*</.test(b)?a.create(b,d):c(b,d)}}catch(b){}return c}())(a,d)},b.ender({find:function(a){var d=[],e,f,g,h,i;for(e=0,f=this.length;e<f;e++){i=c(a,this[e]);for(g=0,h=i.length;g<h;g++)d.push(i[g])}return b(c.uniq(d))},and:function(a){var c=b(a);for(var d=this.length,e=0,f=this.length+c.length;d<f;d++,e++)this[d]=c[e];return this},is:function(a,b){var d,e;for(d=0,e=this.length;d<e;d++)if(c.is(this[d],a,b))return!0;return!1}},!0)}(document,ender)}()

function darkMode() {
    //console.log("dark mode");
    document.body.className = "dark";
}

function sepiaMode() {
    //console.log("sepia mode");
    document.body.className = "sepia";
}

function lightMode() {
    //console.log("light mode");
    document.body.className = "light";
}

function stormMode() {
    //console.log("light mode");
    document.body.className = "storm";
}

function setBodyId(bodyId) {
    //console.log("setting body id to " + bodyId);
    document.body.id = bodyId;
}

// function updateSelectionBubble() {
//   console.log(window.getSelection());
//   console.log(window.getSelection().anchorNode)
//   if (window.getSelection().anchorNode) {
//     var anchor = window.getSelection().anchorNode.parentNode;
//     console.log(anchor);
//     console.log(anchor.offsetTop);
//     console.log(anchor.offsetLeft);
//     console.log(elmXPosition(anchor));
//     console.log(elmYPosition(anchor));
//     document.getElementById("selection-bubble").style.top =  (elmYPosition(anchor)+60)+"px";
//     document.getElementById("selection-bubble").style.left =  elmXPosition(anchor)+"px";    
//   }
  
// }

var bottom = false;
var fontsFallbacks = {
  "lyon": "serif",
  "tisa": "serif",
  "elena": "serif",
  "proxima-nova": "sans-serif",
  "ideal-sans":"sans-serif",
  "meta": "sans-serif"
}

if (typeof Instapaper === "undefined") {
  Instapaper  = {
    log: function(x) { console.log(x); },
    domReady: function() {},
    setProgress: function() {},
    setNumberOfPages: function() {}
  }
}

function speedRead() {
    var text = sanitizeString(document.getElementById("story").innerText);
    var firstWord = findFirstWord(text);
    if (firstWord == -1) firstWord = 0;
    Instapaper.doSpeedRead(text, firstWord);
}

function findFirstWord(text) {
    if (!$('#story').length) {
        return 0;
    }

    var topMostY = Math.max($("#story")[0].getBoundingClientRect().top,0);
    var topMostEl = firstElementAfterOffset(document.getElementById("story"), $(window).scrollTop());
    var word = -1;

    if (topMostEl && topMostEl.id != "story") {
        var str = sanitizeString( topMostEl.innerText);
        var index = text.indexOf(str);
        if (index != -1) {
            word = text.substring(0,index-1).split(" ").length;
        }
    }
    return word;
}

function sanitizeString(text) {
    text = text.replace(/\r?\n/g, " ");
    text = text.replace(/ /," ");
    text = text.replace(/—/g,"— ");
    text = text.replace(/–/g,"– ");
    text = text.replace(/-/g,"- ");
    text = text.replace(/ — /g," ");
    text = text.replace(/ – /g," ");
    text = text.replace(/ - /g," ");
    text = text.replace(/\.\.\./g,"... ");
    text = text.replace(/…/g,"… ");
    text = text.replace(/\//g," ");
    text = text.replace(/\\/g," ");
    text = text.replace(/\s+/g, " ");
    return text.trim();
}


function currentYPosition() {
    // Firefox, Chrome, Opera, Safari
    if (self.pageYOffset) return self.pageYOffset;
    // Internet Explorer 6 - standards mode
    if (document.documentElement && document.documentElement.scrollTop)
        return document.documentElement.scrollTop;
    // Internet Explorer 6, 7 and 8
    if (document.body.scrollTop) return document.body.scrollTop;
    return 0;
}
function elmXPosition(elm) {
    var x = elm.offsetLeft;
    var node = elm;
    while (node.offsetParent && node.offsetParent != document.body) {
        node = node.offsetParent;
        x += node.offsetLeft;
    } return x;
}
function elmYPosition(elm) {
    var y = elm.offsetTop;
    var node = elm;
    while (node.offsetParent && node.offsetParent != document.body) {
        node = node.offsetParent;
        y += node.offsetTop;
    } return y-90;
}

function scrollToEl(element) {
    var startY = currentYPosition();
    var stopY = elmYPosition(element);
    var distance = stopY > startY ? stopY - startY : startY - stopY;
    if (distance < 100) {
        scrollTo(0, stopY); return;
    }
    var speed = Math.round(distance / 10);
    if (speed >= 20) speed = 20;
    var step = Math.round(distance / 25);
    var leapY = stopY > startY ? startY + step : startY - step;
    var timer = 0;
    if (stopY > startY) {
        for ( var i=startY; i<stopY; i+=step ) {
            setTimeout("window.scrollTo(0, "+leapY+")", timer * speed);
            leapY += step; if (leapY > stopY) leapY = stopY; timer++;
        } return;
    }
    for ( var i=startY; i>stopY; i-=step ) {
        setTimeout("window.scrollTo(0, "+leapY+")", timer * speed);
        leapY -= step; if (leapY < stopY) leapY = stopY; timer++;
    }

}

function getEl(current, path) {
  if (path.length == 0) return current;
  var myEl = path.splice(0,1)[0],
      el;
  if (myEl.indexOf("#") == 0) {
    el = document.getElementById(myEl.substring(1));
  } else {
    el = current.children[parseInt(myEl)];
  }
  return getEl(el, path);
}
function ttsHighlight(path) {
  var el = getEl(document, path.split(","))
  $(".ttsHighlight").removeClass("ttsHighlight");
  el.className = el.className+ " ttsHighlight";
  scrollToEl(el);
}

function ttsHighlightSentence(sentence, numOccurrence) {
    $(".ttsHighlight").removeClass("ttsHighlight");
     var el = document.getElementById("story");
     var clipID = new Date().getTime();
     textToFind = sentence.trim();
     search_for = new RegExp(textToFind.replace(/[.*+?|()\[\]{}\\$^]/g,'\\$&').replace(/\s+/g,'\\s+'),'ig');
     doHighlight(el,
                 'ttsHighlight',
                 clipID, search_for, 0, numOccurrence,true);

    goToEl($(".ttsHighlight")[0]);

}


function goToEl(el) {
    if (paginationEnabled) {
        var page = Math.floor(elmXPosition(el) / getColumnWidth());
        goToPage(page);
    } else {
        scrollToEl(el);
    }

}

function getScrollPosition() {
    if (paginationEnabled) {
      return;
    }
    var pageYOffset = window.pageYOffset;
    var documentHeight = document.body.scrollHeight;
    var progress = pageYOffset / documentHeight;
    //console.log("progress: " + pageYOffset + " / " + documentHeight + " = " + progress);
    scrollProgress = progress;
    Instapaper.setProgress(progress);
}

function scrollToProgress(progress) {
    if (progress > 0 && !paginationEnabled) {
        var documentHeight = document.body.scrollHeight;
        var position = progress * documentHeight;
        //console.log("scrollToProgress: " + progress + "  documentHeight: " + documentHeight + "  position: " + position);
        window.scrollTo(0, position);
    }
    
}

function setTopPadding(padding) {
  paddingTop = padding;
  document.body.style.paddingTop="0";
  if (paginationEnabled) {
    $("#viewport")[0].style.margin = (paddingTop+marginTop)+"px 0 0 0";

  } else {
    // document.body.style.paddingTop=paddingTop+"px";
    $("#viewport")[0].style.margin = (paddingTop+marginTop+12)+"px "+ margin+"px "+margin +"px " + margin +"px";
  }

}


function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(location.search);
    return results == null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}


function instapaperLoaded() {
  document.body.onresize = null;
    //console.log("resized: " + document.body.scrollHeight);
    Instapaper.domReady();
    window.onscroll = getScrollPosition;
    
    var marginVal = getParameterByName("margin");
    margin = marginVal == "" ? 30 : parseInt(marginVal);
    
    var lineHeightVal = getParameterByName("lh");
    lineHeight = lineHeightVal == "" ? 1 : parseFloat(lineHeightVal);

    var fontSizeVal = getParameterByName("fontSize");
    fontSize = fontSizeVal == "" ? 16 : parseInt(fontSizeVal);

    var marginTopVal = getParameterByName("marginTop");
    marginTop = marginTopVal == "" ? 16 : parseInt(marginTopVal);

    var fontFamily = getParameterByName("font");
    font = fontFamily == "" ? "serif": (fontFamily + ", " +fontsFallbacks[fontFamily.toLowerCase()]);

    var paginateVal = getParameterByName("paginate");
    paginationEnabled = paginateVal == "true" ? true : false;


    var progress = getParameterByName("progress");
    scrollProgress = progress == "" ? 0 : parseFloat(progress);

    var colorMode = getParameterByName("mode");
    colorMode = colorMode == "" ? "light" : colorMode;

    var w = getParameterByName("w");
    windowWidth = w == "" ? getWindowWidth() : parseInt(w);

    var h = getParameterByName("w");
    windowHeight = h == "" ? getWindowHeight() : parseInt(h);

    var r = getParameterByName("report_label");
    reportLabel = r == "" ? "Report a Problem" : r;
    // $("#ip_report_label").text(reportLabel);
    var url = $("a", $("#footer")).attr('href')
    // var originalLine = $('.orig_line').html();
    var footer  = $("#footer");
    var author = $("#footer .author");
    if (author.length > 0) {
        var footerLink = $("#footer a");
        var bullet = document.createElement("span");
        bullet.innerHTML = "&middot";
        footerLink[0].parentNode.insertBefore(bullet, footerLink[0].nextSibling);
    }

    var img = $("img", $("span", $("#footer")));
    if (img.length > 0) {
      img.remove();
    }

    $("#footer").html( 
                "<span class='orig_line'>"+ $("span", $("#footer")).html() +"</span>"
                +'<div id="footer_buttons">'
                   +' <div id="sharenotes">'
                  +'  <a id="sharenotes_container" onclick="Instapaper.shareAllNotes();">'
                    +'    <div id="sharenotes_icon"></div>'
                      +'  Share All Notes'
                    +'</a>'
                +'</div>'
                +'<div id="reportproblem">'
                 +'   <a id="reportproblem_container"  onclick="return showReportText(window.event || event);">'
                  +'      <div id="reportproblem_icon"></div>'
                        +reportLabel
                    +'</a>'
                +'</div>'
            + '</div>'
            +'<div id="fin"><br/><br/>&#9670;<br/><br/><br/></div>'
            )


 originalWidth = windowWidth;
    originalHeight = windowHeight;

    var of = getParameterByName("of");
    correctionOffset = of == "" ? 10 : parseInt(of);


    // Init values:
    var storyEl = document.getElementById("story")
    storyEl.style.fontSize = fontSize+"px";
    storyEl.style.lineHeight = lineHeight;
    document.body.style.fontFamily = font;
    
    // $("#viewport")[0].style.bottom = margin+"px";

    docHeight = document.body.scrollHeight;
    
    if (colorMode == "dark") {
      darkMode();
    } else if (colorMode == "sepia") { 
      sepiaMode();
    } else if (colorMode == "storm") {
     stormMode();
    } else {
      lightMode();
    }
    setTopPadding(40);

    if (paginationEnabled) {
      newPaginate(windowWidth,windowHeight);
      Instapaper.showWebView();
    } else {
      document.getElementById("viewport").style.margin = (marginTop+paddingTop+12)+"px "+ margin+"px "+margin +"px " + margin +"px";
      if (scrollProgress > 0) scrollToProgress(scrollProgress);
      Instapaper.showWebView();
    }

    // window.addEventListener('deviceorientation', function(eventData) {
    //   setTimeout(function() { handleOrientationChange() }, 400);
    // }, false);

}

function copySelection() {
    Instapaper.copySelection(window.getSelection().toString());
}

function showDefinition() {
    var word = window.getSelection().toString().trim();
    if (word != "") {
        viewDefinition(word.toLowerCase(), "<i>Looking up <b>"+word+"</b>...</i>");
        setTimeout( function() { Instapaper.getDefinition(word) }, 100);
    }
}

var definitionEl;
var isFullScreen = false;

function showFootnote( html) {
    var justAdded = false;
    if (!definitionEl) {
        justAdded = true;
        var wrapper = document.createElement('a');
        wrapper.href = "#definition";
        wrapper.className = "dictwrapper"
        definitionEl = document.createElement('div');
        definitionEl.className = "dictionary";
        wrapper.appendChild(definitionEl);
        document.body.appendChild(wrapper);
    }

    if (isFullScreen) {
        definitionEl.style.paddingBottom = "5px"
    } else {
        definitionEl.style.paddingBottom = "50px"
    }
    definitionEl.innerHTML = html;

    if (definitionEl.className.indexOf("visible") == -1) {
        definitionEl.className = "dictionary visible";
        if (!justAdded) {
            definitionEl.style.webkitTransform = "translateY(0px)";
        } else {
            setTimeout(function() { definitionEl.style.webkitTransform = "translateY(0px)"; }, 100);
        }
    }
    Instapaper.setFootnoteVisible(true);

}

function viewDefinition( word,  definition) {
    var justAdded = false;
    if (!definitionEl) {
        justAdded = true;
        var wrapper = document.createElement('a');
        wrapper.href = "#definition";
        wrapper.className = "dictwrapper"
        definitionEl = document.createElement('div');
        definitionEl.className = "dictionary";
        wrapper.appendChild(definitionEl);
        document.body.appendChild(wrapper);
    }

    if (isFullScreen) {
        definitionEl.style.paddingBottom = "5px"
    } else {
        definitionEl.style.paddingBottom = "50px"
    }
    definitionEl.innerHTML = "<div class='word'>"+word+"</div><ul>"+definition+"</ul><p align='right' onclick='Instapaper.showWiktionary(\""+ word + "\")'>From Wiktionary</p>";

    $(".ipdirectlink", definitionEl).click(function(el) {
        var $this = $(this);
        var text = $this.attr("href" ).substr(14);
        Instapaper.getDefinition(text);
    });

    if (definitionEl.className.indexOf("visible") == -1) {
        definitionEl.className = "dictionary visible";
        if (!justAdded) {
            definitionEl.style.webkitTransform = "translateY(0px)";
        } else {
            setTimeout(function() { definitionEl.style.webkitTransform = "translateY(0px)"; }, 100);
        }
    }

}

function speakVisibleText() {
    Instapaper.speakFrom(wordAndOccurrenceNearestToYOffset(window.pageYOffset));
}

function firstElementAfterOffset(el, offset) {
    if (el == undefined || el.innerText == undefined)
        return undefined;
    var text = el.innerText.replace(/(\r\n|\n|\r)/gm," ").trim();
    if (text.length == 0)
        return undefined;
    else if (el.getBoundingClientRect().top + window.pageYOffset > offset) {
        return el;
    }

    for (var i = 0; i < el.children.length; i++) {
        if (el.children[i].nodeName.toLowerCase() == 'a')
            continue;
        var ret = firstElementAfterOffset(el.children[i], offset);
        if (ret != undefined)
            return ret;
    }

    return undefined;
}

function wordAndOccurrenceNearestToYOffset(offset) {
    var story = document.getElementById('story');
    var element = firstElementAfterOffset(story, offset);
    if (!element) {
        return JSON.stringify({});
    } else {
        var text = element.innerText.replace(/(\r\n|\n|\r)/gm," ").trim();
        var firstWord = text.split(' ')[0];
        var range = document.createRange();
        range.setStartBefore(document.getElementById('story'));
        range.setEnd(element, 0);
        var occurrence = indexOfTextOccurrenceInRange(firstWord, range);
        //return JSON.stringify({'word': firstWord, 'occurrence':occurrence});
        Instapaper.speakFrom(firstWord, occurrence);
    }
}

function indexOfTextOccurrenceInRange(text, range) {
    var textPrecedingSelection = range.toString();
    var regex = highlightRegex(text);
    var result = null;
    var count = 0;
    while ((result = regex.exec(textPrecedingSelection))) {
        count++;
    }
    return count;
}


function onFullScreenOn() {
    isFullScreen = true;
    definitionEl.style.paddingBottom = "5px"
}

function onFullScreenOff() {
    isFullScreen = false;
    if (definitionEl != null) definitionEl.style.paddingBottom = "50px"
}


function getElementsWithTagByAttrValue(tag, attribute, value) {
    var tags = document.getElementsByTagName(tag);
    var ret = [];
    for (var i = 0; i < tags.length; i++) {
        var tag = tags[i];
        if (tag.getAttribute(attribute) == value) {
            ret.push(tag);
        }
    }
    return ret;
}

function setVideoOffline(url) {
    var iframes = getElementsWithTagByAttrValue('iframe', 'src', url);
    for (var i = 0; i < iframes.length; i++) {
        var iframe = iframes[i];
        iframe.src = 'about:blank';
        iframe.parentNode.classList.add('offline');
    }
}

function closeDefinition() {
    currentFootnote = null;
    definitionEl.style.webkitTransform = "translateY("+ ($(definitionEl).height()+50) +"px)";
    definitionEl.className = "dictionary";
}
function handleOrientationChange() {
    if (originalWidth == windowWidth) {
        windowWidth = originalHeight + correctionOffset;
        windowHeight = originalWidth - correctionOffset;
    } else {
        windowWidth = originalWidth;
        windowHeight = originalHeight;
    }
    if (paginationEnabled) {
      newPaginate();
    }

}

var lineHeight, fontSize, margin, marginTop, font, paginationEnabled, scrollProgress, docHeight, colorMode, totalPages, paddingTop = 0, reportLabel, originalWidth, originalHeight,correctionOffset, currentFootnote;

function newUnpaginate() {
  var indicatorsEl = document.getElementById("indicators");
  if (indicatorsEl) indicatorsEl.style.visibility="hidden";
  $("#viewport").removeClass("paginated");
  $("#viewport").addClass("unpaginated");
  paginationEnabled = false;
  var bodyID = document.getElementById('phone');
  bodyID.style.width = "auto";
  bodyID.style.height = "auto";
  bodyID.style.marginLeft = 0;

  bodyID.style.WebkitColumnWidth = ""
  bodyID.style.WebkitColumnGap = "";
  $("#viewport")[0].style.margin = (marginTop+paddingTop+12)+"px "+ margin+"px "+margin +"px " + margin +"px";
  setWindowScroll(0);
  $("#phone").removeClass("animated");
  $("#phone").css("-webkit-transform","");

  scrollToProgress(scrollProgress);
  

}

var calculatedTotalHeight, resetCount = true;


function getWindowWidth() {
     var w = window,
    d = document,
    e = d.documentElement,
    g = d.getElementsByTagName('body')[0],
    x = w.innerWidth || e.clientWidth || g.clientWidth,
    y = w.innerHeight|| e.clientHeight|| g.clientHeight;

    return x;
}

function getWindowHeight() {
     var w = window,
    d = document,
    e = d.documentElement,
    g = d.getElementsByTagName('body')[0],
    x = w.innerWidth || e.clientWidth || g.clientWidth,
    y = w.innerHeight|| e.clientHeight|| g.clientHeight;

    return y;
}

var totalHeight, pageCount;


function newPaginate(width, height, goToCurrentPage) {

  paginationEnabled = true;
  var indicatorsEl = document.getElementById("indicators");
  if (indicatorsEl) indicatorsEl.style.visibility="visible";
  if (!width && !height && !windowWidth && !windowHeight) {
   var w = window,
    d = document,
    e = d.documentElement,
    g = d.getElementsByTagName('body')[0],
    x = w.innerWidth || e.clientWidth || g.clientWidth,
    y = w.innerHeight|| e.clientHeight|| g.clientHeight;

    windowHeight = y; 
    windowWidth = w;
  }

  var marginBottom = 60;
  var body = document.getElementsByTagName('body')[0];
  document.body.style.paddingTop="0";
  $("#viewport")[0].style.marginTop = (paddingTop+marginTop) + "px";
  $("#viewport")[0].style.marginBottom = "0";
  $("#viewport")[0].style.marginLeft = "0";
  $("#viewport")[0].style.marginRight = "0";
  $("#viewport").addClass("paginated");
  $("#viewport").removeClass("unpaginated");

  var bodyID = document.getElementById('phone');
  if (!totalHeight) {
    totalHeight = bodyID.offsetHeight;
  } 

  calculatedTotalHeight = totalHeight;
  var desiredHeight = windowHeight-marginTop-marginBottom;
  var desiredWidth = windowWidth;


  // Guesstimate number of pages
  bodyID.style.height = desiredHeight;
  bodyID.style.marginLeft = margin;

  bodyID.style.WebkitColumnWidth = (desiredWidth-margin*2)+"px";  
  bodyID.style.WebkitColumnGap = (2*margin)+"px";
  pageCount = Math.ceil(totalHeight/desiredHeight);
  bodyID.style.width = desiredWidth * pageCount-margin;
  updatePageCount();
  
  window.scrollTo(0,0);
  if (goToCurrentPage) {
    goToPage(currentPage);
  } else if (scrollProgress > 0) {
    // var offset = scrollProgress * docHeight;
    // var current = 0;
    // var page = 0;
    // while (current < offset+margin*2 ) {
    //   current += getColumnWidth();
    //   page++;
    // }
    // page--;
    var page = Math.floor(scrollProgress * pageCount);
    goToPage(page);
  }
  
  pagesUpdated();
  Instapaper.showWebView();
}

function nextPage() {
  if (currentPage+1 >= pageCount) return;
  goToPage(currentPage+1,true,400);
}

function prevPage() {
  if (currentPage-1 < 0) return;
  goToPage(currentPage-1,true,400);
}

function updatePageCount() {
  var c = pageCount;
  var rightMost = $("#footer")[0].getBoundingClientRect().right+(getTranslateX()*-1);
  if (c*getColumnWidth() > rightMost) {
    while (c*getColumnWidth() > rightMost) c--;
  } else if (c*getColumnWidth()+getColumnWidth() < rightMost) {
    while (c*getColumnWidth()+getColumnWidth() < rightMost) c++;
  }
  pageCount = c+1;
  pagesUpdated();
}

function getColumnWidth() {
  var width = $("#footer")[0].getBoundingClientRect().width+margin*2;
  if (width > document.body.getBoundingClientRect().width * 2) {
    width /= 2;
  }
  return width;
}

function pagesUpdated() {
  
  var height = 20;
  var imgSize = 10, imgMargin = 5;
  var indicatorsEl = document.getElementById("indicators");
  if (!indicatorsEl) {
    indicatorsEl = document.createElement("div");
    indicatorsEl.id = "indicators";
    document.body.appendChild(indicatorsEl);
    indicatorsEl.style.position = "fixed";
    indicatorsEl.style.top = 35;
    indicatorsEl.style.left = 0;
    indicatorsEl.style.right = 0;
    indicatorsEl.style.height="40px";
  }
  
  var pages = Math.min(pageCount,13);
  var html ="<div style='margin:0 auto;width:"+ ((imgMargin+imgSize)*pages)+"px'>";
  var currentDot = pageCount > pages ? Math.floor((currentPage/pageCount)*13) : currentPage;
  for (var i =0 ; i < pages; i++) {
    var imgFile = i == currentDot ? "page_indicator_selected.png" : "page_indicator_non_selected.png";
    html += "<img src='file:///android_asset/"+imgFile+"' style='float:left;max-height:"+imgSize+"px;margin-right:"+imgMargin+"px'>";
  }
  html += "<div style='clear:both;'></div></div>";
  indicatorsEl.innerHTML = html;
  Instapaper.setNumberOfPages(pages);  
}
var windowWidth, windowHeight;


var currentPage = 0;

var lastScrollX, lastScrollY, lastScrollTime, lastVelocity, averageVelocity, initialX, initialStart;
function handleScroll(newX,newY) {
  if (!lastScrollX) {
    initialX = newX;
    lastScrollX = newX;
    lastScrollTime = initialStart = new Date().getTime();
  } else {
    var myTime = new Date().getTime();
    lastScrollX = newX;
    lastScrollTime  = new Date().getTime();
    lastVelocity = Math.abs(newX-lastScrollX)/(myTime-lastScrollTime);
  }
}
function handleScrollEnd(newX,newY) {
  if (!paginationEnabled) return;
  var myTime = new Date().getTime();
    var direction = lastScrollX < initialX ? -1 : 1;
  var deltaX = Math.abs(Math.abs(lastScrollX) -Math.abs(initialX));

  var velocity = deltaX/(myTime-initialStart);

  var remaining = windowWidth - deltaX,
      remainingPct = remaining/windowWidth;

  // v = d/t
  // t = d/v
  var time = remaining/velocity;

  // console.log(velocity);
  // console.log(direction);
  var newPage = currentPage+direction;
  if (time < 800) {

    goToPage(currentPage+direction, true,time);
  } else {
    // Scroll back to currentPage
    time = deltaX/velocity;
    goToPage(currentPage, true,time);
  }
    lastScrollX = null, lastScrollY = null, lastScrollTime = null, lastVelocity = null, averageVelocity = null, initialX = null;

}

// function traverse(el, currentX, sentinel) {
//   var children = $(el).children, i =0;
//   for (i = 0; i < children.length; i++) {
//     var test = traverse(children[i],currentX);
//   }
// }

var currentTextSelection = "";
$.domReady(function () {
    //console.log("dom ready");

    var onresizeTimeout = setTimeout(instapaperLoaded, 500);
    document.body.onresize = function() {
        clearTimeout(onresizeTimeout);
        instapaperLoaded();
    };
      var initialTouchX = null;
      var initialWindowX = null;
        
        var lastTouch;
          
       document.body.addEventListener('touchstart', function(e){
        if (!paginationEnabled) return;
          var touch = e.touches[0]; // Gets information about the first finger, i.e. number 0.
          lastTouch = touch;
          var scrX = touch.pageX; // Get X position including scroll bars
          lastX = scrX;
          initialTouchX = scrX;
          initialWindowX = getWindowScroll();

          var delta = e.x-initialTouchX,
              newX = delta-initialWindowX;
          lastX = newX;
          handleScroll(-1 *newX, 0);

       }, false);

       document.body.addEventListener('touchmove', function(e){
        if (!paginationEnabled) return;
        e.preventDefault();
        if (initialTouchX != null) {
            var touch = e.touches[0]; // Gets information about the first finger, i.e. number 0.
            lastTouch = touch;
            var scrX = touch.pageX; // Get X position including scroll bars
            lastX = scrX;
            var direction = lastX < initialTouchX ? -1 : 1;        
            if (direction == 1 && currentPage == 0) {
              return;
            } else if (direction == -1 && currentPage == totalPages-1) {
              return;
            }

            var delta = scrX-initialTouchX,
            newX = delta-initialWindowX;
            setWindowScroll(newX);
            handleScroll(-1 * newX, 0);
        }
        
       }, false);

       document.body.addEventListener('touchend', function(e){
        if (!paginationEnabled) return;
          // var touch = e.touches[0]; // Gets information about the first finger, i.e. number 0.
          var scrX = lastX; // Get X position including scroll bars

          var delta = scrX-initialTouchX,
              newX = delta-initialWindowX;
        initialTouchX = null;
        initialWindowX = null;
        handleScrollEnd(-1 * newX, 0);
        lastX = null;
       }, false);
    $(".ipfootnote_ref").text("");
    $(".ipfootnote_ref").click(function(e) {
          var $this = $(this);
          var target = $this.attr("href");
          var html = $(target).html();
          showFootnote(html);
          e.stop();
    });

    $("body").click(function(e) {
        if (e.target.nodeName.toLowerCase() != 'a') {
            Instapaper.onTap(e.screenX / window.innerWidth, e.screenY / window.innerHeight);
        }
    });

    $("iframe").each(function() {
        $(this).attr("allowfullscreen", "1");
    });
});

function showReportText(evt) {
    if (evt) {
        evt.stopPropagation();
    }
    Instapaper.showReportTextProblemDialog();
    return false;
}
function setFontSize(s) {
  fontSize = s;
  var storyEl = $("#story")[0];
  storyEl.style.fontSize = fontSize+"px";
  updatePageCount();

  if (scrollProgress >0 ){ 
    var page = Math.floor(scrollProgress * pageCount);
    goToPage(page);    
  }
}

function setMargins(margins) {
  margin = margins;
  if (paginationEnabled) {    
    newPaginate(windowWidth, windowHeight);
    
  } else {
    $("#viewport")[0].style.margin = (marginTop+paddingTop+12)+"px "+ margin+"px "+margin +"px " + margin +"px";
  }
}

function setLH(lh) {
  lineHeight = lh;
  var storyEl = $("#story")[0];
  storyEl.style.lineHeight = lineHeight;  
  updatePageCount();
}

function setFont(fontFamily) {
 font = fontFamily;
  document.body.style.fontFamily = font +"," +fontsFallbacks[fontFamily.toLowerCase()];
  updatePageCount();
  
}

function setWindowScroll(x) {
  $("#window")[0].style.webkitTransform = "translate3d("+(x)+"px,0,0)";

}

function getTranslateXForElement(el) {
    var style = getComputedStyle(el);
    if (style.getPropertyCSSValue != null) {
        var cssTransform = getComputedStyle($("#window")[0]).getPropertyValue("-webkit-transform");
          if (cssTransform != null &&  cssTransform.length > 0 && cssTransform[0].length >=4) {
            var translateX = cssTransform[0][4].cssText;
            var x = translateX.replace("px","");
            return parseInt(x);
          }
    }

    try {
        var cssMatrix = new WebKitCSSMatrix(style.getPropertyValue("-webkit-transform"));
        return cssMatrix.m41;
    } catch (e) {
        console.error(e);
        return undefined;
   }
}


function getTranslateX() {
  var x = getTranslateXForElement($("#phone")[0]);
  if (x != undefined) {
    return x-getWindowScroll();
  }
  return getWindowScroll() * -1;
}


function getWindowScroll() {
  var scrollX  = getTranslateXForElement($("#window")[0]);
  if (scrollX != undefined) {
    return scrollX * -1;
  }
  return 0;
}

function scrollPageTo(x,y, animate, duration) {
  x = Math.ceil(x);
  // Instapaper.log("Scrolling to " + x + " (actually "+(x-getWindowScroll()) +" ) because window is at "+getWindowScroll());
  if (animate) {
    $("#phone").addClass("animated");
    $("#phone").css("-webkit-transition-duration",duration+"ms");
    // $("#phone")[0].style.WebkitTransitionTimingFunction = "ease-in;";
  } else {
    $("#phone").removeClass("animated");
    $("#phone").css("-webkit-transition","");

  }
  x-=getWindowScroll();

    $("#phone").unbind('webkitTransitionEnd').bind('webkitTransitionEnd', function(){
        $("#phone").removeClass("animated");
        $("#phone").css("background","rgba(255,255,255,"+(Math.random()*0.02)+")")
    });

  $("#phone")[0].style.webkitTransform = "translate3d("+(-x)+"px,0,0)";


}

function setProgress(progress) {
    scrollProgress = progress;
    if (paginationEnabled) {
        var page = Math.floor(scrollProgress * pageCount);
        goToPage(page);
    } else {
        scrollToProgress(scrollProgress);
    }

}


function goToPage(pageNum,animate, duration) {
  duration = duration || 0;
  if (pageNum >= pageCount) {
    pageNum = pageCount-1;
  }
  currentPage = pageNum;
  scrollProgress = (pageNum+1)/pageCount;
  Instapaper.setProgress(scrollProgress);

  var columnWidth = getColumnWidth();
  scrollPageTo(columnWidth*pageNum,0,animate,duration);
  pagesUpdated();


/*
  if (!best) {
    // Boundry
    totalPages = pageNum;
    resetCount = false;
    pagesUpdated();
    goToPage(pageNum-1,animate,duration);
    return;
  }*/

}








/***** TEXT HIGHLIGHTING *****/


 function highlightRegex(text) {
     // rhill 2012-01-29: escape regex chars first
     // http://stackoverflow.com/questions/280793/case-insensitive-string-replacement-in-javascript
     return new RegExp(text.replace(/[.*+?|()\[\]{}\\$^]/g,'\\$&'),'ig');
 }

 /**************** HIGHLIGHTING CODE ***************************/
 // Using the excellent highlighter code from Raymond Hill
 // Author: Raymond Hill
 // Version: 2011-01-17
 // Title: HTML text hilighter
 // Permalink: http://www.raymondhill.net/blog/?p=272
 // Purpose: Hilight portions of text inside a specified element, according to a search expression.
 // Key feature: Can safely hilight text across HTML tags.
 // History:
 //   2012-01-29
 //     fixed a bug which caused special regex characters in the
 //     search string to break the highlighter

 function doHighlight(node,className,clipID,searchFor,which,index,clickHandler,isNote,noteClickHandler){
    var doc = document;
            
    // normalize node argument
    if (typeof node === 'string') {
        node = doc.getElementById(node);
    }
            
    // normalize search arguments, here is what is accepted:
    // - single string
    // - single regex (optionally, a 'which' argument, default to 0)
    if (typeof searchFor === 'string') {
        searchFor = highlightRegex(searchFor);
    }
    which = which || 0;
    index = index || 0;
            
    // initialize root loop
    var indices = [],
        text = [], // will be morphed into a string later
        iNode = 0,
        nNodes = node.childNodes.length,
        nodeText,
        textLength = 0,
        stack = [],
        child, nChildren,
        state,
        noteCreated = false;
    // collect text and index-node pairs
    for (;;){
        while (iNode<nNodes){
               child=node.childNodes[iNode++];
            // text: collect and save index-node pair
            if (child.nodeType === 3){
                indices.push({i:textLength, n:child});
                nodeText = child.nodeValue;
                text.push(nodeText);
                textLength += nodeText.length;
            }
            // element: collect text of child elements,
            // except from script or style tags
            else if (child.nodeType === 1){
                // skip style/script tags
                if (child.tagName.search(/^(script|style)$/i)>=0){
                    continue;
                }
                // add extra space for tags which fall naturally on word boundaries
                if (child.tagName.search(/^(a|b|basefont|bdo|big|em|font|i|s|small|span|strike|strong|su[bp]|tt|u)$/i)<0){
                    text.push(' ');
                    textLength++;
                }
                // save parent's loop state
                nChildren = child.childNodes.length;
                if (nChildren){
                    stack.push({n:node, l:nNodes, i:iNode});
                    // initialize child's loop
                    node = child;
                    nNodes = nChildren;
                    iNode = 0;
                }
            }
        }
        // restore parent's loop state
        if (!stack.length){
            break;
        }
        state = stack.pop();
        node = state.n;
        nNodes = state.l;
        iNode = state.i;
    }
    
    // quit if found nothing
    if (!indices.length){
        return;
    }
    
    // morph array of text into contiguous text
    text = text.join('');
    
    // sentinel
    indices.push({i:text.length});
    
    // find and hilight all matches
    var iMatch, matchingText,
    iTextStart, iTextEnd,
    i, iLeft, iRight,
    iEntry, entry,
    parentNode, nextNode, newNode,
    iNodeTextStart, iNodeTextEnd,
    textStart, textMiddle, textEnd;
    
    matchingText = null;
    for (var i = 0; i <= index; i++) {
        // find matching text, stop if none
        matchingText = searchFor.exec(text);
        if (!matchingText || matchingText.length<=which || !matchingText[which].length){
            break;
        }
    }
    
    if (!matchingText)
        return;
        
    // calculate a span from the absolute indices
    // for start and end of match
    iTextStart = matchingText.index;
    for (iMatch=1; iMatch < which; iMatch++){
        iTextStart += matchingText[iMatch].length;
    }
    iTextEnd = iTextStart + matchingText[which].length;
        
    // find entry in indices array (using binary search)
    iLeft = 0;
    iRight = indices.length;
    while (iLeft < iRight) {
           i=iLeft + iRight >> 1;
        if (iTextStart < indices[i].i){iRight = i;}
        else if (iTextStart >= indices[i+1].i){iLeft = i + 1;}
        else {iLeft = iRight = i;}
    }
    iEntry = iLeft;
        
    // for every entry which intersect with the span of the
    // match, extract the intersecting text, and put it into
    // a span tag with specified class
    while (iEntry < indices.length){
        entry = indices[iEntry];
        node = entry.n;
        nodeText = node.nodeValue;
        parentNode = node.parentNode;
        nextNode = node.nextSibling;
        iNodeTextStart = iTextStart - entry.i;
        iNodeTextEnd = Math.min(iTextEnd,indices[iEntry+1].i) - entry.i;
            
        // slice of text before hilighted slice
        textStart = null;
        if (iNodeTextStart > 0){
            textStart = nodeText.substring(0,iNodeTextStart);
        }
            
        // hilighted slice
        textMiddle = nodeText.substring(iNodeTextStart,iNodeTextEnd);
            
        // slice of text after hilighted slice
        textEnd = null;
        if (iNodeTextEnd < nodeText.length){
            textEnd = nodeText.substr(iNodeTextEnd);
        }
            
        // update DOM according to found slices of text
        if (textStart){
            node.nodeValue = textStart;
        }
        else {
            parentNode.removeChild(node);
        }
        newNode = doc.createElement('span');
        newNode.appendChild(doc.createTextNode(textMiddle));
        newNode.className = className;
        newNode.setAttribute('rel', clipID);
        if (clickHandler)
            newNode.addEventListener('click', clickHandler, false);
        parentNode.insertBefore(newNode,nextNode);
        if (textEnd){
            if (isNote) {
                newNode = doc.createElement('span');
                newNode.setAttribute('id', 'ipnote-' + clipID);
                newNode.className = 'ipnote';
                newNode.setAttribute('rel', clipID);
                if (noteClickHandler)
                    newNode.addEventListener('click', noteClickHandler, false);
                parentNode.insertBefore(newNode, nextNode);
                if (newNode.getBoundingClientRect().top < newNode.parentNode.getBoundingClientRect().top) {
                  // In pagination mode, when the highlighted paragraph is at the end, the icon is inserted to the next page. 
                  // In this case we use Y-position for the previous element
                  newNode.style.float="right";
                }                
                noteCreated = true;
            }
            
            newNode = doc.createTextNode(textEnd);
            parentNode.insertBefore(newNode,nextNode);
            indices[iEntry] = {n:newNode,i:iTextEnd}; // important: make a copy, do not overwrite
        }
            
        // if the match doesn't intersect with the following
        // index-node pair, this means this match is completed
        iEntry++;
        if (iTextEnd <= indices[iEntry].i){
            if (isNote && !noteCreated) {
                newNode = doc.createElement('span');
                newNode.setAttribute('id', 'ipnote-' + clipID);
                newNode.className = 'ipnote';
                newNode.setAttribute('rel', clipID);
                if (noteClickHandler)
                    newNode.addEventListener('click', noteClickHandler, false);
                parentNode.insertBefore(newNode, nextNode);
            }
            return;
        }
    }
}


function quickHighlight(clipID, textToFind, index, isNote) {
    textToFind = textToFind.trim();
    search_for = new RegExp(textToFind.replace(/[.*+?|()\[\]{}\\$^]/g,'\\$&').replace(/\s+/g,'\\s+'),'ig');
    doHighlight(document.getElementById('story'),
                'highlight highlight-' + clipID,
                clipID, search_for, 0, index, highlightTapped, isNote, noteTapped);
}

 function highlightWithJson(highlights, scrollToHighlight) {
   for (var i = 0; i < highlights.length; i++) {
       try {
           quickHighlight(highlights[i].id, highlights[i].text, highlights[i].index,highlights[i].note != null);
       } catch(err) {
           ;
       }
   }
   if (scrollToHighlight) {
      if (paginationEnabled) {
          var page = Math.floor(elmXPosition(document.getElementsByClassName('highlight-' + scrollToHighlight)[0]) / getColumnWidth());
          goToPage(page);
      } else {
          scrollToEl(document.getElementsByClassName('highlight-' + scrollToHighlight)[0]);
      }
   }
 }

 function setHasNotes(hasNotes) {
  if (hasNotes) {
    $("#sharenotes").removeClass("hidden");
  } else {
    $("#sharenotes").addClass("hidden");
  }
 }

 function indexOfSelectedTextOccurrence() {
     var selection = window.getSelection();
     var range = selection.getRangeAt(0);
     var precedingRange = document.createRange();
     precedingRange.setStartBefore(document.getElementById('story'));
     precedingRange.setEnd(range.startContainer, range.startOffset);
     var textPrecedingSelection = precedingRange.toString();
     var regex = highlightRegex(selection.toString());
     var result = null;
     var count = 0;
     while ((result = regex.exec(textPrecedingSelection))) {
         count++;
     }
     return count;
 }

function noteTapped(event) {
    var noteIcon = event.target;
    if (noteIcon == null || noteIcon.nodeName.toLowerCase() != 'span') return;
    
    var boundingRect = noteIcon.getBoundingClientRect();
    var noteId = noteIcon.getAttribute('rel');
    var rect = noteRect(noteId)
    Instapaper.noteTapped(noteId,rect.x,rect.y,rect.width,rect.height, window.innerWidth, window.innerHeight,false);

    event.preventDefault();
    event.stopPropagation();
}


function dictForClientRect(rect) {
    if (rect == undefined) {
        return {"x": 0, "y": 0, "width": 0, "height": 0};
    }
    
    return {"x": rect.left, "y": rect.top + window.pageYOffset-window.scrollY, "width": rect.width, "height": rect.height};
}
        
function noteRect(highlightId) {
    var noteElement = document.getElementById('ipnote-' + highlightId);
    var noteDict = dictForClientRect(!noteElement? undefined: noteElement.getBoundingClientRect());;
    return noteDict;
}



 function highlightTapped(event) {
    var highlight = event.target;
    if (highlight == null || highlight.nodeName.toLowerCase() != 'span') return;
    
    var parentWidth = document.getElementById('story').offsetWidth;
    var targetRectWidth, targetRectHeight;
    var highlightOffset = [highlight.offsetLeft, highlight.offsetTop];
    if (highlightOffset[0] + highlight.offsetWidth > parentWidth) {
        targetRectWidth = parentWidth - highlightOffset[0];
        targetRectHeight = parseInt(document.defaultView.getComputedStyle(highlight, null).getPropertyValue('font-size'));
    } else {
        targetRectWidth = highlight.offsetWidth;
        targetRectHeight = highlight.offsetHeight;
    }
    
    if (targetRectWidth < 10) targetRectWidth = 20;
    if (targetRectHeight < 10) targetRectHeight = 15;
    
    // window.location.href =
    //     'linktap:///?' +
    //     'href=' + encodeURIComponent('highlight://' + highlight.getAttribute('rel')) +
    //     '&x=' + parseInt(highlightOffset[0]) + '&y=' + parseInt(highlightOffset[1]) + '&w=' + parseInt(targetRectWidth) + '&h=' + parseInt(targetRectHeight)
    ;
    event.preventDefault();
    Instapaper.highlightTapped(highlight.getAttribute('rel'));
     $(".highlight.tapped").removeClass("tapped");
    $('.highlight[rel~="'+highlight.getAttribute('rel')+'"]').addClass('tapped');
}


function unselectHighlight() {

 $(".highlight.tapped").removeClass("tapped");
}


function highlightSelection(highlightId, index, showAddNote) {
   var selection = window.getSelection();
   var highlights = document.getElementsByClassName('highlight');
   var removeHighlightIds = [];
   for (var i = 0; i < highlights.length; i++) {
       if (selection.containsNode(highlights[i], true)) {
           removeHighlightIds.push(highlights[i].getAttribute('rel'));
       }
   }

   quickHighlight(highlightId, selection.toString(), index);
   Instapaper.removeHighlights(removeHighlightIds.join(","));

   if (showAddNote) {
    var noteIcon = addNoteForHighlight(highlightId);
    var boundingRect = noteIcon.getBoundingClientRect();
    var noteId = noteIcon.getAttribute('rel');
    var rect = noteRect(noteId);
    Instapaper.showNoteEditor(noteId,rect.x,rect.y,rect.width,rect.height, window.innerWidth, window.innerHeight, true);
   }
}

function showAddNoteForHighlight(highlightId) {
  var noteIcon = addNoteForHighlight(highlightId);
  var boundingRect = noteIcon.getBoundingClientRect();
  var noteId = noteIcon.getAttribute('rel');
  var rect = noteRect(noteId);
  Instapaper.showNoteEditor(noteId,rect.x,rect.y,rect.width,rect.height, window.innerWidth, window.innerHeight, false);  
}

function addNoteForHighlight(highlightId) {
    var highlights = document.getElementsByClassName('highlight-' + highlightId);
    var lastHighlight = highlights[highlights.length - 1];
    var newNode = document.createElement('span');
    newNode.setAttribute('id', 'ipnote-' + highlightId);
    newNode.className = 'ipnote';
    newNode.setAttribute('rel', highlightId);
    newNode.addEventListener('click', noteTapped, false);
    lastHighlight.parentNode.insertBefore(newNode, lastHighlight.nextSibling);
    if (newNode.getBoundingClientRect().top < newNode.parentNode.getBoundingClientRect().top) {
      // In pagination mode, when the highlighted paragraph is at the end, the icon is inserted to the next page. 
      // In this case we use Y-position for the previous element
      newNode.style.float="right";
    }

    return newNode;
}


function removeHighlightList() {
    for (var i=0;i < arguments.length;i++) {
       removeHighlight(arguments[i]);
    }
}
function removeHighlight(highlightId) {
     var highlights = document.getElementsByClassName('highlight-' + highlightId);
     for (var i = 0; i < highlights.length; i++) {
         highlights[i].classList.remove('highlight');
         highlights[i].removeEventListener('click', highlightTapped);
     }
    
    removeNote(highlightId);
}
        
function removeNote(highlightId) {
    var noteIcon = document.getElementById('ipnote-' + highlightId);
    if (noteIcon) {
        noteIcon.parentNode.removeChild(noteIcon);
    }
}


function createNewHighlight(showAddNote) {
  if (window.getSelection().toString() != "") {
    console.log("Creating new highlight");
    Instapaper.createHighlight(window.getSelection().toString(), indexOfSelectedTextOccurrence(),showAddNote);

  }
}


function createTweetShot() {
  if (window.getSelection().toString() != "") {
    Instapaper.doCreateTweetShot(window.getSelection().toString());
  }
}



